import React from "react";
import classes from "../assets/styles/components/answerModal.module.scss";
import MyButton from "./MyButton.jsx";
import MarkDowm from "./MarkDown.jsx";

const AnswerModal = ({
    cleanStates, 
    currentTypeAnswer, 
    updateBlock,
    stateModal,
    addFormBlock, 
    question, 
    file,
    video,
    setVideo,
    listTypeAnswer,
    optionAnswer,
    setOptionAnswer,
    currentOptionAnswer,
    setCurrentOptionAnswer,
    comment, 
    mandatory,
    setMandatory,
    addOptionAnswer,
    setQuestion,
    setComment,
    setCurrentTypeAnswer,
    setFile,
    removeOptionAnswer
    }) => {

    return (
        <div class="modal fade modal-lg myModal" className={classes.myModal} id="answerModal" tabIndex="-1" aria-labelledby="exampleModalLabel" data-bs-backdrop="static" aria-hidden="true">
            <div class="modal-dialog myModal__dialog" className={classes.myModal__dialog}>
                <div class="modal-content" className={classes.myModal__dialog__content}>
                    <div class="modal-header" className={classes.myModal__dialog__content__header}>
                        <h5 class="modal-title" id="exampleModalLabel">Редактирование вопроса</h5>
                        <select value={currentTypeAnswer} onChange={e => setCurrentTypeAnswer(Number(e.target.value))}>
                            {listTypeAnswer.map((item, i) => 
                                <option value={item.id} key={i}>{item.text}</option>
                            )}
                        </select>
                    </div>
                    <div class="modal-body" className={classes.myModal__dialog__content__body}>
                        <div className={classes.myModal__dialog__content__body__answer}>
                            <span className={classes.myModal__dialog__content__body__answer__title}>Вопрос</span>
                            <MarkDowm mkValue={question} setMkValue={setQuestion}></MarkDowm>
                            <input 
                                type="file" 
                                multiple 
                                accept="image/*,image/jpeg,video/mp4,video/x-m4v,video/*" 
                                className={classes.myModal__dialog__content__body__answer__file}
                                value={file}
                                onChange={event => setFile(event.target.value)}
                            ></input>                     
                        </div>
                        <div className={classes.myModal__dialog__content__body__comment}>
                            <span className={classes.myModal__dialog__content__body__comment__title}>Комментарий</span>
                            <textarea className={classes.myModal__dialog__content__body__comment__text} value={comment} onChange={event => setComment(event.target.value)}></textarea>
                        </div>
                        <div className={classes.myModal__dialog__content__body__video}>
                            <span className={classes.myModal__dialog__content__body__video__title}>Видео</span>
                            <input type="text" className={classes.myModal__dialog__content__body__video__link} placeholder="Ссылка на видео" value={video} onChange={(e) => setVideo(e.target.value)}/>
                        </div>
                        {[3, 4, 5].find(item => item === currentTypeAnswer) ? <div className={classes.myModal__dialog__content__body__answerOptions}>
                            <span className={classes.myModal__dialog__content__body__answerOptions__title}>Варианты ответа</span>
                            <div className={classes.myModal__dialog__content__body__answerOptions__list}>
                                {optionAnswer.map((item, i) => 
                                    <span key={i} className={classes.myModal__dialog__content__body__answerOptions__list__answer}>
                                        {item.id}) {item.text} 
                                        <i class="fa-solid fa-xmark" onClick={() => removeOptionAnswer(item.id)}></i>
                                    </span>
                                )}
                            </div>
                            <input 
                                type="text" 
                                className={classes.myModal__dialog__content__body__answerOptions__text} 
                                value={currentOptionAnswer} 
                                onChange={event => setCurrentOptionAnswer(event.target.value)}
                            />
                            <MyButton 
                                text={'Добавить'} 
                                click={addOptionAnswer}
                                class={"main__white"}
                                otherStyle={{padding: '1% 2%'}}
                            />
                        </div> : <div></div>}
                        <div className={classes.myModal__dialog__content__body__mandatory}>
                            <span className={classes.myModal__dialog__content__body__mandatory__title}>Обязательный вопрос</span>
                            <input className={classes.myModal__dialog__content__body__mandatory__choice} type="checkbox" checked={mandatory} onChange={() => setMandatory(!mandatory)}/>
                        </div>
                    </div>
                    <div class="modal-footer myModal__dialog__content__footer" className={classes.myModal__dialog__content__footer}>
                        <button type="button" class="btn btn-light" data-bs-dismiss="modal" onClick={cleanStates}>Отмена</button>
                        <button type="button" class="btn" style={{color: 'white', backgroundColor: 'rgb(150, 209, 158)'}} data-bs-dismiss="modal" onClick={stateModal ? updateBlock : addFormBlock}>Сохранить</button>
                    </div>
                </div>
            </div>
        </div>
    )
}

export default AnswerModal;